// kevin powell
// https://www.youtube.com/watch?v=c13gpBrnGEw

.content-grid {

    // grid variables:

    --padding-inline: 2rem;
    --content-max-width: 72ch;
    --breakout-max-width: 88ch;

    // grid sizing formulas:

    --full-computed: minmax(var(--padding-inline), 1fr);

    --breakout-max-size: calc(
        (var(--breakout-max-width) - var(--content-max-width)) / 2
    );

    --breakout-computed: minmax(0, var(--breakout-max-size));

    --content-computed: min(
        100% - (var(--padding-inline) * 2),
        var(--content-max-width)
    );

    // grid engine:

    display: grid;

    grid-template-columns:
        [full-width-start] var(--full-computed)
        [breakout-start] var(--breakout-computed)

        [content-start] var(--content-computed) [content-end]

        var(--breakout-computed) [breakout-end]
        var(--full-computed) [full-width-end]
    ;

    // grid children:

    > :not(.breakout, .full-width) {
        grid-column: content;
    }

    > .breakout {
        grid-column: breakout;
    }

    > .full-width {
        grid-column: full-width;
    }
}
